/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.fw.file.dao.standard;

import java.util.Map;

import jp.terasoluna.fw.file.annotation.FileFormat;
import jp.terasoluna.fw.file.annotation.OutputFileColumn;
import jp.terasoluna.fw.file.dao.FileException;

/**
 * Œ蒷t@Cp̃t@CANZX(f[^)NX.
 * <p>
 * t@CsIuWFNgf[^ǂݍ݁A 1s̃f[^Œ蒷`Ńt@CɏށB
 * </p>
 * <b>pt@CsIuWFNg̃Ame[V</b><br>
 * @D@{@link FileFormat}̐ݒ荀<br>
 * <div align="center">
 * <table width="90%" border="1" bgcolor="#FFFFFF">
 * <tr>
 * <td><b>_ږ</b></td>
 * <td><b>ږ</b></td>
 * <td><b>ftHgl</b></td>
 * <td><b>K{</b></td>
 * </tr>
 * <tr>
 * <td> <code>s؂蕶</code></td>
 * <td> <code>lineFeedChar</code></td>
 * <td> <code>VXe̍s؂蕶</code></td>
 * <td> <code>IvV</code></td>
 * </tr>
 * <tr>
 * <td> <code>t@CGR[fBO</code></td>
 * <td> <code>fileEncoding</code></td>
 * <td> <code>VXẽt@CGR[fBO</code></td>
 * <td> <code>IvV</code></td>
 * </tr>
 * <tr>
 * <td> <code>t@C㏑tO</code></td>
 * <td> <code>overWriteFlg</code></td>
 * <td> <code>false</code></td>
 * <td> <code>IvV</code></td>
 * </tr>
 * </table>
 * </div> <br>
 * AD@{@link jp.terasoluna.fw.file.annotation.InputFileColumn}A@{@link OutputFileColumn}̐ݒ荀<br>
 * <div align="center">
 * <table width="90%" border="1" bgcolor="#FFFFFF">
 * <tr>
 * <td><b>_ږ</b></td>
 * <td><b>ږ</b></td>
 * <td><b>ftHgl</b></td>
 * <td><b>K{</b></td>
 * </tr>
 * <tr>
 * <td> <code>JCfbNX</code></td>
 * <td> <code>columnIndex</code></td>
 * <td>-</td>
 * <td> <code>K{</code></td>
 * </tr>
 * <tr>
 * <td> <code>tH[}bg</code></td>
 * <td> <code>columnFormat</code></td>
 * <td> <code>""</code></td>
 * <td> <code>IvV</code></td>
 * </tr>
 * <tr>
 * <td> <code>oCg</code></td>
 * <td> <code>bytes</code></td>
 * <td> <code>-1</code></td>
 * <td> <code>IvV</code></td>
 * </tr>
 * <tr>
 * <td> <code>pfBO</code></td>
 * <td> <code>paddingType</code></td>
 * <td> <code>pfBOȂ</code></td>
 * <td> <code>IvV</code></td>
 * </tr>
 * <tr>
 * <td> <code>pfBO</code></td>
 * <td> <code>paddingChar</code></td>
 * <td> <code>' '</code></td>
 * <td> <code>IvV</code></td>
 * </tr>
 * <tr>
 * <td> <code>g</code></td>
 * <td> <code>trimType</code></td>
 * <td> <code>gȂ</code></td>
 * <td> <code>IvV</code></td>
 * </tr>
 * <tr>
 * <td> <code>g</code></td>
 * <td> <code>trimChar</code></td>
 * <td> <code>' '</code></td>
 * <td> <code>IvV</code></td>
 * </tr>
 * <tr>
 * <td> <code>ϊ</code></td>
 * <td> <code>stringConverter</code></td>
 * <td> <code>NullStringConverter.class</code></td>
 * <td> <code>IvV</code></td>
 * </tr>
 * </table>
 * </div> <br>
 * <b>ӎ</b><br>
 * <ul>
 * @
 * <li>؂蕶ݒ肷邱Ƃ͏oȂB(G[)</li> @
 * <li>͂ݕݒ肷邱Ƃ͏oȂB(G[)</li>
 * </ul>
 * @param <T> t@CsIuWFNgB
 */
public class FixedFileLineWriter<T> extends AbstractFileLineWriter<T> {

    /**
     * ؂蕶BŒ蒷t@Ću'\u0000'vŌŒB
     */
    private static final char DELIMITER = Character.MIN_VALUE;

    /**
     * ͂ݕBŒ蒷t@Ću'\u0000'vŌŒB
     */
    private static final char ENCLOSE_CHAR = Character.MIN_VALUE;

    /**
     * RXgN^B
     * @param fileName t@C
     * @param clazz p[^NX
     * @param columnFormatterrMap eLXg擾[
     */
    public FixedFileLineWriter(String fileName, Class<T> clazz,
            Map<String, ColumnFormatter> columnFormatterrMap) {

        super(fileName, clazz, columnFormatterrMap);

        FileFormat fileFormat = clazz.getAnnotation(FileFormat.class);

        // ؂蕶lȊȌꍇAOX[B
        if (fileFormat.delimiter() != ',') {
            throw new FileException("Delimiter can not change.",
                    new IllegalStateException(), fileName);
        }

        // ͂ݕlȊȌꍇAOX[B
        if (fileFormat.encloseChar() != ENCLOSE_CHAR) {
            throw new FileException("EncloseChar can not change.",
                    new IllegalStateException(), fileName);
        }

        // s؂蕶ݒ肷B
        // Œ蒷̏ꍇ̂݉s邽߁AsuperNXł̐ݒ㏑B
        setLineFeedChar(fileFormat.lineFeedChar());

        // 
        super.init();
    }

    /**
     * ΏۃJɑ΂oCg`FbNsԂB<br>
     * FixedFileLineWriter͌Œ蒷̂߁AK`FbNs悤trueԋpB<br>
     * s\ĥ߁AsPʂ̃oCg`FbN͍sȂB
     * @param outputFileColumn ΏۃJOutputFileColumn
     * @return true
     */
    @Override
    protected boolean isCheckByte(OutputFileColumn outputFileColumn) {

        return true;
    }

    /**
     * ΏۃJɑ΂oCg`FbNsԂB<br>
     * FixedFileLineWriter͌Œ蒷̂߁AK`FbNs悤trueԋpB<br>
     * s\ĥ߁AsPʂ̃oCg`FbN͍sȂB
     * @param columnByte ΏۃJ̃oCg
     * @return true
     */
    @Override
    protected boolean isCheckByte(int columnByte) {

        return true;
    }

    /**
     * ͂ݕݒ肳ĂȂ`FbN邩ԂB<br>
     * FixedFileLineWriter͌Œ蒷̂߁A͂ݕ͐ݒ肵ȂB<br>
     * ̂߈͂ݕݒ肳ĂȂ`FbNB
     * @return `FbNsꍇtrueB
     */
    @Override
    protected boolean isCheckEncloseChar() {
        return true;
    }

    /**
     * ؂蕶擾B<br>
     * Œ蒷t@Ću'\u0000'vŌŒB
     * @return ؂蕶
     */
    public char getDelimiter() {

        return DELIMITER;
    }

    /**
     * ͂ݕ擾B<br>
     * Œ蒷t@Ću'\u0000'vŌŒB
     * @return ͂ݕ
     */
    public char getEncloseChar() {

        return ENCLOSE_CHAR;
    }

}
